//@ts-nocheck
/* tslint:disable */
/* eslint-disable */
/**
 * This is an open API that holds specific endpoints as a base for Pieces Context Systems
 * The point of this API is to allow us to organize and Auto Generate Code Specific for Connected Applications - this will allow for stateful context abstraction & less code within the Core Connector
 *
 * The version of the OpenAPI document: 1.0
 * Contact: tsavo@pieces.app
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    EmbeddedModelSchema,
    EmbeddedModelSchemaFromJSON,
    EmbeddedModelSchemaFromJSONTyped,
    EmbeddedModelSchemaToJSON,
    GroupedTimestamp,
    GroupedTimestampFromJSON,
    GroupedTimestampFromJSONTyped,
    GroupedTimestampToJSON,
    HintTypeEnum,
    HintTypeEnumFromJSON,
    HintTypeEnumFromJSONTyped,
    HintTypeEnumToJSON,
    MechanismEnum,
    MechanismEnumFromJSON,
    MechanismEnumFromJSONTyped,
    MechanismEnumToJSON,
    ReferencedAsset,
    ReferencedAssetFromJSON,
    ReferencedAssetFromJSONTyped,
    ReferencedAssetToJSON,
    ReferencedModel,
    ReferencedModelFromJSON,
    ReferencedModelFromJSONTyped,
    ReferencedModelToJSON,
} from './';

/**
 * This is a hint that is attached to an asset, used for suggested_queries, and hints given via the qgpt flow.
 * @export
 * @interface Hint
 */
export interface Hint {
    /**
     * 
     * @type {EmbeddedModelSchema}
     * @memberof Hint
     */
    schema?: EmbeddedModelSchema;
    /**
     * 
     * @type {string}
     * @memberof Hint
     */
    id: string;
    /**
     * 
     * @type {GroupedTimestamp}
     * @memberof Hint
     */
    created: GroupedTimestamp;
    /**
     * 
     * @type {GroupedTimestamp}
     * @memberof Hint
     */
    updated: GroupedTimestamp;
    /**
     * 
     * @type {GroupedTimestamp}
     * @memberof Hint
     */
    deleted?: GroupedTimestamp;
    /**
     * 
     * @type {MechanismEnum}
     * @memberof Hint
     */
    mechanism?: MechanismEnum;
    /**
     * 
     * @type {ReferencedAsset}
     * @memberof Hint
     */
    asset?: ReferencedAsset;
    /**
     * 
     * @type {HintTypeEnum}
     * @memberof Hint
     */
    type: HintTypeEnum;
    /**
     * This is the text of the hint.
     * @type {string}
     * @memberof Hint
     */
    text: string;
    /**
     * 
     * @type {ReferencedModel}
     * @memberof Hint
     */
    model?: ReferencedModel;
}

export function HintFromJSON(json: any): Hint {
    return HintFromJSONTyped(json, false);
}

export function HintFromJSONTyped(json: any, ignoreDiscriminator: boolean): Hint {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'schema': !exists(json, 'schema') ? undefined : EmbeddedModelSchemaFromJSON(json['schema']),
        'id': json['id'],
        'created': GroupedTimestampFromJSON(json['created']),
        'updated': GroupedTimestampFromJSON(json['updated']),
        'deleted': !exists(json, 'deleted') ? undefined : GroupedTimestampFromJSON(json['deleted']),
        'mechanism': !exists(json, 'mechanism') ? undefined : MechanismEnumFromJSON(json['mechanism']),
        'asset': !exists(json, 'asset') ? undefined : ReferencedAssetFromJSON(json['asset']),
        'type': HintTypeEnumFromJSON(json['type']),
        'text': json['text'],
        'model': !exists(json, 'model') ? undefined : ReferencedModelFromJSON(json['model']),
    };
}

export function HintToJSON(value?: Hint | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'schema': EmbeddedModelSchemaToJSON(value.schema),
        'id': value.id,
        'created': GroupedTimestampToJSON(value.created),
        'updated': GroupedTimestampToJSON(value.updated),
        'deleted': GroupedTimestampToJSON(value.deleted),
        'mechanism': MechanismEnumToJSON(value.mechanism),
        'asset': ReferencedAssetToJSON(value.asset),
        'type': HintTypeEnumToJSON(value.type),
        'text': value.text,
        'model': ReferencedModelToJSON(value.model),
    };
}


